 //**************************************************\\
   //           Data Conversion Routines               \\
   //**************************************************\\
    var convertBase = function (num) {
        this.from = function (baseFrom) {
            this.to = function (baseTo) {
                return parseInt(num, baseFrom).toString(baseTo).toUpperCase();
            };
            return this;
        };
        return this;
    };   
    // binary to decimal
    this.bin2dec = function (num) {
        return convertBase(num).from(2).to(10);
    };
    // binary to hexadecimal
    this.bin2hex = function (num) {
        return convertBase(num).from(2).to(16);
    };
    // decimal to binary
    this.dec2bin = function (num) {
        return convertBase(num).from(10).to(2);
    };
    // decimal to hexadecimal
    this.dec2hex = function (num) {
        return convertBase(num).from(10).to(16);
    };
    // hexadecimal to binary
    this.hex2bin = function (num) {
        return convertBase(num).from(16).to(2);
    };
    // hexadecimal to decimal
    this.hex2dec = function (num) {
        return convertBase(num).from(16).to(10);
    };

//**************************************************\\
//    converts an array of hex or decimal to the    \\
//    the ASCII code                                \\
//         eg 75 Decimal  = K                       \\
//**************************************************\\
  this.NumToChar = function(tmp) {
       var arr = tmp;
       var str = '';
       var c;    
       for (var i=0; i<arr.length; i++) {
           if (arr[i] != 0) {
             c = String.fromCharCode(arr[i]);
             str += c;
           }  
       }
       return str;
   }
//**************************************************\\
//            Formats eg FF into 0xFF               \\
//**************************************************\\
   this.FormatToHex = function(hx){   
      hx = '0x' + String('0' + hx).slice(-2); 
      return hx;    
   }
